## cpprest 2.10.15

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(cpprestsdk-root NONE)
enable_testing()
add_subdirectory(Release)
