=== Release/tests/common/CMakeLists.txt ===
add_subdirectory(utilities)
add_subdirectory(UnitTestpp)
add_subdirectory(TestRunner)
