=== debian/changelog ===
cpprest (2.10.15-1) unstable; urgency=medium

  * New upstream version 2.10.15
  * Refresh patch
  * std-version, bump to 4.5.0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 27 Feb 2020 15:15:54 +0100

cpprest (2.10.14-3) unstable; urgency=medium

  * Fix cmake installation directory (LP: #1838826)
  * std-version, bump to 4.4.1

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 09 Jan 2020 12:04:29 +0100
