=== debian/changelog ===
cpprest (2.10.16-2) unstable; urgency=medium

  * Disable one more test using internet connection

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 May 2020 22:54:29 +0200

cpprest (2.10.16-1) unstable; urgency=medium

  * New upstream version 2.10.16

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 May 2020 11:46:28 +0200
