=== debian/changelog ===
cpprest (2.10.17-2) unstable; urgency=medium

  * Do a build also on arch:all to avoid install failures

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 08 Jan 2021 12:34:20 +0100

cpprest (2.10.17-1) unstable; urgency=medium

  * New upstream version 2.10.17
  * Bump compat level to 13
  * Bump copyright years

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 08 Jan 2021 10:36:33 +0100
