## cpprest 2.10.18

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)
project(cpprestsdk-root NONE)
enable_testing()
add_subdirectory(Release)
