=== Build_iOS/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 project(casablanca-ios NONE)
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.9)
 
 enable_testing()
