=== Release/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 set(CPPREST_VERSION_MAJOR 2)
 set(CPPREST_VERSION_MINOR 10)
-set(CPPREST_VERSION_REVISION 17)
+set(CPPREST_VERSION_REVISION 18)
 
 enable_testing()
