=== debian/changelog ===
cpprest (2.10.18-1build2) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 23 Nov 2021 15:24:25 +0100

cpprest (2.10.18-1build1) hirsute; urgency=medium

  * No change rebuild with fixed ownership.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Feb 2021 16:55:07 +0000

cpprest (2.10.18-1) unstable; urgency=medium

  * Update watch file for new release
  * New upstream version 2.10.18

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 08 Feb 2021 16:09:24 +0100
