=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: cpprest
 Section: libs
 Priority: optional
-Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libbrotli-dev,
                libboost-atomic-dev,
                libboost-chrono-dev,
