=== debian/watch ===
version=4
opts=dversionmangle=s/(\+|\.)dfsg$// \
        https://github.com/Microsoft/cpprestsdk/tags .*/(\d\S*)\.tar\.gz
